#!/usr/bin/python3

#	cve-manager : CVE management tool
#	Copyright (C) 2017-2022 Alexey Appolonov
#
#	This program is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	This program is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with this program.  If not, see <http://www.gnu.org/licenses/>.

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

from cve_manager.defines import M_PRESCRIBED, M_URL, M_COMPLETE, M_PARTIAL, \
	M_BIN_COMPLETE, M_BIN_PARTIAL, M_FIXES, M_CHOICES

# # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #

NAME_MAX_LEN = 128

# M_ stands for MATCHING_
M_URL_GRADE_A = f'{M_URL}_grade_a'
M_URL_GRADE_B = f'{M_URL}_grade_b'
M_URL_EXPANDED = [M_URL_GRADE_A, M_URL_GRADE_B]
M_CHOICES_EXPANDED = M_CHOICES[:1] + M_URL_EXPANDED + M_CHOICES[2:]

# TM_ stands for TYPE_OF_MATCHING_
TM_INVARIANT = [M_PRESCRIBED] + M_URL_EXPANDED + [M_COMPLETE, M_BIN_COMPLETE]
TM_VARIATIVE = [t for t in M_CHOICES_EXPANDED if t not in TM_INVARIANT]
TM_VARIATIVE_NORM = [M_PARTIAL, M_BIN_PARTIAL]
TM_VARIATIVE_NOT_NORM_EXP = [M_FIXES]
TM_VARIATIVE_NOT_NORM_LIN = [t for t in TM_VARIATIVE if t not in
	TM_VARIATIVE_NORM + TM_VARIATIVE_NOT_NORM_EXP]
TM_SRC = [M_PRESCRIBED] + M_URL_EXPANDED + [M_COMPLETE, M_PARTIAL, M_FIXES]
TM_BIN = [t for t in M_CHOICES_EXPANDED if t not in TM_SRC]

IGNORED_NETLOCS = {
	'securityfocus.com',
	'ibmcloud.com',
	'osvdb.org',
	'secunia.com',
	'vupen.com',
	'securitytracker.com',
	'exploit-db.com',
	'debian.org',
	'opensuse.org',
	'securityreason.com',
	'marc.info',
	'gentoo.org',
	'mandriva.com',
	'cisecurity.org',
	'openwall.com',
	'ubuntu.com',
	'redhat.com',
	'fedoraproject.org',
	'oracle.com',
	'docs.google.com',
	'neohapsis.com',
	'seclists.org',
	'novell.com',
	'packetstormsecurity.com',
	'security.netapp.com',
	'apple.com',
	'mozilla.org',
	'support.avaya.com',
	'sun.com',
	'iss.net',
	'jvn.jp',
	'blogspot.com',
	'rpath.com',
	'vmware.com',
	'slackware.com',
	'zerodayinitiative.com',
	'jvn.jp',
	'conectiva.com.br',
	'shownotes.sf.net',
	'ibm.com',
	'kernel.org',
	}
